---
title: "『情報コース』もっとくわしく編"
description: "『情報コース』では Raspberry Pi やブロックプログラム開発環境『オコゲ』、センサやモータなどを使用して、楽しみながら ICT や IoT などの情報技術を学習します。"
date: 2022-04-27
thumb: "ogp_tama-graphig.webp"
tags:
    - ICT-Course
    - 動画
---

『情報コース』では、シングルボードコンピュータ『Raspberry Pi』や独自仕様のブロックプログラミング開発・実行環境『オコゲ』、各種センサやモータなどを使用してプログラミングを楽しく学び、ICT (Information and Communication Technology – 情報通信技術) や IoT (Internet of Things – モノのインターネット) などの情報技術を習得することを目的としています。

## Raspberry Pi シングルボードコンピュータ

{% floatbox {
    img: 'raspi.webp',
    title: 'Raspberry Pi と きなこもち',
    width: '400px',
    colortheme: 'silver'
} %}
<i class="fa-solid fa-magnifying-glass"></i> クリックで拡大
{% endfloatbox %}

{% link_new {uri: 'https://ja.wikipedia.org/wiki/Raspberry_Pi',title: 'Wikipedia'} %}Raspberry Pi{% endlink_new %} は、イギリスの{% link_new {uri: 'https://www.raspberrypi.org/',title: 'Raspberry Pi Foundation'} %}ラズベリーパイ財団{% endlink_new %}によって主に教育で利用することを想定して開発された{% link_new {uri: 'https://ja.wikipedia.org/wiki/%E3%82%B7%E3%83%B3%E3%82%B0%E3%83%AB%E3%83%9C%E3%83%BC%E3%83%89%E3%82%B3%E3%83%B3%E3%83%94%E3%83%A5%E3%83%BC%E3%82%BF',title: 'Wikipedia'} %}シングルボードコンピュータ{% endlink_new %}です。小型・軽量で低価格、性能は価格なりですが、OS (基本ソフト) に Linux (Debian) を採用し、モニタとキーボード、マウスを接続してデスクトップを備えた GUI が使える、れっきとしたパーソナルコンピューターです。モニタは HDMI 入力のあるテレビでも代用でき、導入コストが低いのが特徴です。PC と大きく異なる点は {% link_new {uri: 'https://ja.wikipedia.org/wiki/GPIO',title: 'Wikipedia'} %}GPIO{% endlink_new %} ( General-purpose input/output – 汎用入出力) 端子の存在で、ここに各種センサやモータなどを接続して数値を読み 取ったり制御したりすることができます。つまり、コンピュータが物理的に「感じ」たり、「動い」たりすることができるのです。

## ブロックプログラミング開発・実行環境『オコゲ』

{% floatbox {
    img: 'ocoge.webp',
    title: '『オコゲ』デフォルトスクリーン',
    width: '400px',
    colortheme: 'silver'
} %}
<i class="fa-solid fa-magnifying-glass"></i> クリックで拡大
{% endfloatbox %}

『オコゲ』は、{% link_new {uri:'https://developers.google.com/blockly', title:'A JavaScript library for building visual programming editors.'} %}Google Blockly{% endlink_new %} ライブラリを使用した、Raspberry Pi 用ブロックプログラミング環境です。

ブロックプログラミング (Block-Based Coding) は、コンピュータへの命令が記述されたブロックを並べたり積み重ねることでプログラムを作成するプログラミングの形式で、主にプログラミング学習の目的で使用されています。学生がプログラム言語を覚えたりタイピングを習得する苦労やストレスから解放され、プログラミングの概念そのものを学習することに専念できるからです。また、何ができるかが一目でわかり簡単に試してみることができ、子供（大人でも！）の創造性を強く刺激します。

ブロックプログラミングツールの最も有名なもののひとつに {% link_new {uri:'https://scratch.mit.edu/', title:'物語や、ゲーム、アニメーションを作ろう 世界中のみんなと共有しよう'} %}Scratch{% endlink_new %} があります。{% link_new {uri:'https://ja.scratch-wiki.info/wiki/Scratch%E3%82%AD%E3%83%A3%E3%83%83%E3%83%88', title:'Wikipedia'} %}『スクラッチの猫ちゃん』(Scratch cat){% endlink_new %} を見たことがあるかもしれません。その Scratch も、バージョン２までは Macromedia (Adobe) Flash で作られていましたが、最新のバージョン３では Google Blockly ベースになりました。ブロックプログラミングツールのもうひとつの代表格 {% link_new {uri:'https://www.microsoft.com/ja-jp/makecode', title:'プログラミング教育のハンズオン'} %}Microsoft MakeCode{% endlink_new %} も Blockly を元にしています。

## Raspberry Pi + オコゲ = ?

では、Raspberry Pi と『オコゲ』を組み合わせると何ができるのでしょうか。その一部を動画でご紹介します。

{% iconbox {
    iconclass: 'fa-solid fa-circle-exclamation'
} %}
※動画ではブロックの色や形状などの『オコゲ』の見た目や周辺機器が最近更新された記事と異なりますが、機能や内容に変更はありません。
{% endiconbox %}

### デモンストレーション

{% youtube {
    videoid: 'Q8CCj9NnLHM'
} %}
{% endyoutube %}

『情報コース』で使用する機材の一部を使用した動作サンプルです。

- 『Julius』との連携による音声認識
- サーボモータ制御
- Lチカ
- 温湿度センサー
- 赤外線LEDによるリモコン（キーボードに乗っけてあるミニライト）
- 接触が悪くてLEDが発光しなかったカメラ
- 画像ファイルのロードと表示

### 飲み過ぎ防止システム

{% youtube {
    videoid: 'CQ3bTddq_-E'
} %}
{% endyoutube %}

IoT のとってもくだらない例。２杯目からもうコンピュータに怒られる。

### スマートスイッチ

{% youtube {
    videoid: 'OdciAgMR5bA'
} %}
{% endyoutube %}

Raspberry Pi につないだサーボモータで物理的に照明のスイッチをオンオフします。操作は『オコゲ』を通じて音声で行います。ちょっと強力な両面テープと結束バンドだけでできる工事いらずのスマートホームです。

### 顔認識

{% youtube {
    videoid: 'vasLwxYlqco'
} %}
{% endyoutube %}

カメラモジュールの映像をリアルタイムで処理してヒトの顔を認識し、その座標情報を使用してペーパークラフト人形の顔の向きを制御しています。動画ではちょっとわかりにくいかもしれませんが、お人形がずっとこちらを見続けていますヨー。

### ネットワーク

{% youtube {
    videoid: '87JHKVDVQpI'
} %}
{% endyoutube %}

ネットワークにつながるだけでプログラミングのアイディアは大きく広がります。例えば２つ上の「スマートスイッチ」は音声でコントロールしていますが、これをネットワークにつなげれば、出先や離れからスマートフォンなどを通じて照明のオンオフができるようになるでしょう。
『オコゲ』は簡単にウェブサーバとそれにアクセスするためのクライアントを作ることができます。動画では、音声合成LSI「{% link_new {uri: 'https://www.a-quest.com/products/aquestalkpicolsi.html',title: 'ゆっくり'} %}AquesTalk pico{% endlink_new %}」を接続したサーバ側 Raspberry Pi に、ミニディスプレイをつないだクライアント側 Raspberry Pi から LAN 経由で HTTP 接続をして朝のあいさつや「吾輩は猫である」の朗読をさせています。

### ウェブチャット

{% youtube {
    videoid: '0YVbnBv4CmU'
} %}
{% endyoutube %}

用途が限定された特殊ブロックもあります。この例では、WebRTC（ウェブブラウザ上でシンプルなリアルタイムコミュニケーションを実現する技術）を使用してテキストベースのウェブチャットを実装しています。

### ゲーム制作

{% youtube {
    videoid: 'Xb3O9ttwyx8'
} %}
{% endyoutube %}

テレビゲームっぽいものも作れます。

## 『オコゲ』にさわってみよう

ここまでご覧になって「おもしろそう！」と思った方は、ぜひ当学習塾に… の前に、Web 体験版を触ってみましょう。サンプルプログラムや、自分で考えてサンプルを改良するプチレッスンをご用意しております。

{% blogcard {link:'http://localhost/2022-05-07_demo/'} %}