---
title: "ブロックプログラミング環境『オコゲ』"
description: "『オコゲ』は、Google Blockly ライブラリを使用して作られた、Raspberry Pi 向けブロックプログラミング環境です。"
date: 2022-05-01
thumb: "ogp_ocoge.webp"
tags: オコゲ
---

『オコゲ [ocoge: code generator]』は、 {% link_new {uri: 'https://developers.google.com/blockly',title: 'A JavaScript library for building visual programming editors.'} %}{% endlink_new %} Google Blockly ライブラリを使用した、Raspberry Pi 用ブロックプログラミング環境です。 プログラム言語を覚える必要がなく、未経験の方でもすぐにプログラミングの楽しさを体験することができます。

## デモンストレーション

{% blogcard {link:'http://localhost/2022-05-07_demo/'} %}

## 機能と特徴

- Google Blockly を用いたブロックプログラミングによる開発・実行環境  
特別な機能を持ったブロックをつなげていくだけでプログラムを組み立てることができます。プログラム言語を覚える必要がないため、アルゴリズム（処理の手順）を考えることに集中できます。また、作成したプログラムは『オコゲ』上ですぐに実行することができます。
- GPIO 入出力  
Raspberry Pi の GPIO（汎用入出力端子）に接続したセンサや LED、サーボモータなどを操作するプログラムを作成・実行できます。
- Javascript コードジェネレータ  
ブロックで作成したプログラムを Javascript 言語で出力・閲覧することができます。次のステップ（コードによるプログラミング）に進むための足がかりになります。

## その他技術情報

- {% link_new {uri: 'https://nodejs.org/',title: ''} %}Node.js{% endlink_new %} + {% link_new {uri: 'https://www.electronjs.org/',title: ''} %}Electron{% endlink_new %} によりデスクトップアプリケーションとして動作
- GPIO ライブラリには {% link_new {uri: 'https://abyz.me.uk/lg/index.html',title: ''} %}rgpio{% endlink_new %} を使用し、{% link_new {uri: 'https://git.ocoge.club/ocogeclub/ocoge/src/branch/master/local_modules/rgpio',title: ''} %}自作ネイティブモジュール{% endlink_new %}により『オコゲ』から直接 GPIO へのアクセスが可能。