---
title: "『ゲーム電卓パイ』プロジェクト"
description: "Raspberry Pi と LCD キャラクタディスプレイモジュールで「ゲーム電卓」を再現してみる"
date: 2022-06-14
thumb: "ogp_game-dentak.webp"
tags:
    - オコゲ
    - デスクトップアプリ版
---

{% simplebox 'box_stripe' %}CASIO のレトロガジェット「ゲーム電卓」を、デスクトップ版『オコゲ』と LCD キャラクタディスプレイモジュールで作成します。  
※ コード開発と記事は同時進行ですので、まったり更新＆内容変更有です。{% endsimplebox %}

## 「ゲーム電卓」とは

> ゲーム電卓（ゲームでんたく）は、卓上電子計算機にコンピュータゲームの機能を盛り込んだ多機能化商品。1980年代の電子ゲーム流行の際に大手電卓メーカー等から発売された。 {% link_new {uri: 'https://ja.wikipedia.org/wiki/%E3%82%B2%E3%83%BC%E3%83%A0%E9%9B%BB%E5%8D%93',title: 'Wikipedia'} %}Wikipedia | ゲーム電卓{% endlink_new %}

ここでは、CASIO から発売された「デジタルインベーダー」SM880 の復刻版である SL-880 を指すこととします。プレイのイメージは、以下のサイトの動画をご覧ください。

{% link_new {uri: 'https://www.casio.com/jp/basic-calculators/product.SL-880/',title: ''} %}メーカー製品ページ{% endlink_new %}  
{% link_new {uri: 'https://www.casio.com/content/dam/casio/global/support/manuals/calculators/pdf/004-ja/s/SL-880_WA_JA.pdf',title: ''} %}取扱説明書{% endlink_new %}  
{% link_new {uri: 'https://kakakumag.com/houseware/?id=11983',title: ''} %}価格.comマガジン{% endlink_new %}

{% talkicon_r {img: 'mimmy.webp', name: 'ミミィ'} %}{% says_r %}
懐かしいヮ・・・  
「AIM」キーと「FIRE」キーがユルユルになるまで遊んだものョ・・・ハッ
{% endsays_r %}
{% talkicon_l {img: 'tama.webp', name: 'タマちー'} %}{% think_l %}
ミミィって歳いくつなんだろ・・・
{% endthink_l %}

## ハードウェア

- Raspberry Pi 4B (8GB)
- {% link_new {uri: 'https://akizukidenshi.com/catalog/g/gK-12238/',title: ''} %}I2C 接続小型 LCD モジュール{% endlink_new %}
- {% link_new {uri: 'https://akizukidenshi.com/catalog/g/gP-04118/',title: ''} %}圧電サウンダ{% endlink_new %}
- {% link_new {uri: 'https://www.google.com/search?q=b3f-1000&oq=b3f-1000&aqs=edge..69i57j0i512l2j0i30l2j0i5i30.6451j0j9&sourceid=chrome&ie=UTF-8',title: ''} %}タクトスイッチ{% endlink_new %}

記事中では、これらの部品をブレッドボードとワイヤ類で接続して使用します。

## 回路構成

{% floatbox {
    img: 'game-dentak_fritzing.webp',
    title: 'ゲーム電卓パイ',
    width: '300px',
    colortheme: 'silver'
} %}
<i class="fa-solid fa-magnifying-glass"></i> クリックで拡大
{% endfloatbox %}

以下は配線の一例です。

| LCD キャラクタディスプレイ | Raspberry Pi GPIO (BCM) |
|-|-|
| A | 3V3（バックライト不要の場合は接続不要） |
| VDD | 3V3 |
| RESET | 3V3 または 10kΩ でプルアップ |
| GND | GND |
| SDA | 22<sup>*</sup>  |
| SCL | 23<sup>*</sup>  |
| K | GND（バックライト不要の場合は接続不要） |
 
\* I2C バス１（GPIO2-3）を使用する場合、キャラクタディスプレイには{% link_new {uri: 'https://akizukidenshi.com/catalog/g/gK-11354/',title: ''} %}こちら{% endlink_new %}を使用

| 圧電サウンダ | Raspberry Pi GPIO (BCM) |
|-|-|
| 片方 | 20  |
| もう片方 | GND |

| タクトスイッチ | Raspberry Pi GPIO (BCM) |
|-|-|
| 左 | 26 |
| 右 | 19 |
| 左右 GND | GND |

{% talkicon_l {img: 'tama.webp', name: ''} %}{% says_l %}
次回に続く・・・
{% endsays_l %}
{% talkicon_r {img: 'mimmy.webp', name: ''} %}{% says_r %}
キャラクタディスプレイに文字を表示してみるわ！
{% endsays_r %}

{% blogcard {link:'http://localhost/2022-06-21_aqm0802a/'} %}