---
title: "海外からいろいろ届いたよ"
description: "RP2040 ベースのマイクロコントローラユニットをいくつか買ってみました。"
date: 2022-07-26
thumb: "ogp_rp2040boards.webp"
tags:
    - RP2040
    - Pico
---

{% talkicon_r {img: 'mimmy.webp', name: 'ミミィ'} %}{% says_r %}
ちょっとRP2040マイクロコントローラユニット (MCU) を色々買ってみたワ！  
RP2040 はラズベリーパイ財団が開発したマイクロコントローラで、Raspberry Pi Pico に搭載されているものヨ！
{% endsays_r %}

> マイクロコントローラとは、CPU(Central Processing Unit：中央処理装置)とメモリ等の周辺機能が１チップに集積された半導体の一つです。日本では、「マイコン」と呼ばれることもありますが、海外では通じない事が多いです。CPUは、ソフトウェアによるプログラムに従い演算や制御を行います。そのためにプログラムを格納するROMや演算データを一時記憶するRAMなどのメモリが周辺機能として内蔵されることが多く、その他にタイマやADコンバータと呼ばれる様々な機能も追加され現在では家電やOA機器、車載など多くのアプリケーションに採用されています。{% link_new {uri: 'https://www.epson.jp/prod/semicon/products/micro_controller/about_mcu1.htm',title: 'EPSON'} %}マイクロコントローラ（MCU）とは？ - エプソン{% endlink_new %}

{% centerimg 'rp2040boards.webp' %}

{% endcenterimg %}

| No | MCU | フラッシュ | ピン数 | 外寸<sup>1</sup> | USB | 価格 |
|-|-|-|-|-|-|-|
| 1 | {% link_new {uri: 'https://www.raspberrypi.com/documentation/microcontrollers/raspberry-pi-pico.html',title: 'Raspberry Pi Foundation'} %}Raspberry Pi Pico{% endlink_new %} | 2MB | 20x2+3 | 51×21mm | micro | 527円<sup>2</sup> |
| 2 | Raspberry Pi Pico W | 2MB | 20x2+3 | 51×21mm | micro | 810円<sup>2</sup> |
| 3 | {% link_new {uri: 'https://www.waveshare.com/rp2040-zero.htm',title: 'WAVESHSRE'} %}Waveshare RP2040-Zero{% endlink_new %} | 2MB | 9x2+5 | 23.5x18mm | Type-C | 517円<sup>3</sup> |
| 4 | {% link_new {uri: 'https://shop.pimoroni.com/products/tiny-2040?variant=39560012234835',title: '海賊ロボ忍者さる'} %}PIMORONI Tiny 2040{% endlink_new %} | 8MB<sup>4</sup> | 8x2+3 | 21x18mm | Type-C | 1,134円<sup>2</sup> |
| 5 | RP2040 Black Board New Type | 4MB<sup>5</sup> | 20x2+4 | 53x23mm | Type-C | 405円<sup>3</sup> |
{% small 1 %}基板部のみの大きさ{% endsmall %}  
{% small %}PIMORONIの日本円表示価格 (送料別 - 小物なので800円くらい){% endsmall %}  
{% small %}AliExpressの価格 (送料込・当方購入時の最低価格){% endsmall %}  
{% small %}2MB版もある{% endsmall %}  
{% small %}16MB版もある (700円くらい) {% endsmall %}  

{% talkicon_l {img: 'tama.webp', name: 'タマちー'} %}{% says_l %}
1,2 はオリジナル、4 はイギリスの有名ベンダーの製品、3,5 は中華製なの・・・
{% endsays_l %}

{% talkicon_r {img: 'mimmy.webp', name: ''} %}{% says_r %}
中華製品は基盤の仕上げとか動作のクセとか、些細なところで大きなストレスを与えてくるのよネ！
本質と違うところで苦労したくなければ中華は避けるべきヨ！
{% endsays_r %}

{% talkicon_l {img: 'tama.webp', name: ''} %}{% think_l %}
ヘンなモジュールで安く遊びたい変態さんには中華製超オススメ・・・
{% endthink_l %}

{% talkicon_r {img: 'mimmy.webp', name: ''} %}{% says_r %}
アンタ・・・
{% endsays_r %}

{% simplebox 'box_stripe' %}
ただ、オリジナルの Pico に全く問題がないのかというとそうでもなく、例えばリセットボタンがない、基盤の上面にピン番号が印刷されていない、USB 端子形状が micro USB であるなど、使い勝手の悪い部分があります。まあこの辺りは Raspberry Pi コンピュータも同様なので、そういう思想なのでしょう。  
そういうわけで、現在当方では小さいサイズに Tiny 2040 、普通サイズに RP2040 Black Board New Type を使用中。どちらも、リセットボタン、ピン番号のシルク印刷、USB Type-C、大容量のフラッシュメモリ、フルカラーLED搭載。加えて後者は送込み400円のお陰で、やらかしてしまっても怖くないのがイイ。
{% endsimplebox %}

