---
eleventyExcludeFromCollections: true
title: "上野学習塾『情報コース』"
description: "「情報コース」ランディングページ"
date: Last Modified
thumb: "ogp_it-kizai.webp"
---

上野学習塾では、来たるべき情報教育時代に向けて、IoT 技術を中心とした「情報」科目を学ぶことのできるクラスを開設いたします。

## IoT とは…

Internet of Things、日本語で「モノのインターネット」といい、PCやスマートフォンなどの情報端末だけではなく、身のまわりのあらゆる「モノ」がインターネットに接続され、情報交換することで相互に制御する仕組みのことです。それには「モノ」が何らかの形でコンピュータにつながる必要がありますが、ここにディスプレイやキーボードといった「インターフェース」ではなく「センサー」を使用することで、「モノ」と「ネット」の、人間を介在しない接続が可能になります。IoT の入り口ともいえるこの技術は「フィジカルコンピューティング」と呼ばれています。

{% youtube {
    videoid: 'CQ3bTddq_-E'
} %}
IoTのくだらなすぎる例。飲みすぎるとコンピュータに叱られる。{% link_new "https://notify-bot.line.me/ja/", "Webサービスからの通知をLINEで受信" %}LINE Notify{% endlink_new %} と連携して奥様にも叱られることができれば、それはもう立派なIoTだ
{% endyoutube %}

## 学校でプログラミング？

{% floatbox {
    img: 'it-set.webp',
    title: 'IoT 学習セット',
    width: '400px',
    colortheme: ''
} %}
IoT 学習セット：当塾で使用する予定の機材の一例。ご家庭でも導入しやすい構成
{% endfloatbox %}

2020年度から「新学習指導要領」が小中高校で順次実施されます。その中に「情報活用能力を、言語能力と同様に{% strong {color:'red'} %}学習の基盤となる資質・能力{% endstrong %}と位置付け」、小学校では「{% strong {color:'blue'} %}プログラミング的思考{% endstrong %}を育成」し、中学では「{% strong {color:'blue'} %}ネットワークを利用した{% endstrong %}双方向性のあるコンテンツのプログラミング」を学び、高校では{% strong {color:'blue'} %}共通必履修科目{% endstrong %}「情報I」を新設する、とあります。2024年には大学入学共通テストにこの「情報I」の導入が検討されています。今すぐ対策を！ということではありませんが、コンピュータに実際に触れプログラムを組むという経験が、大きなアドバンテージとなるであろうことは間違いありません。

## 子供たちの選択肢を広げるために

10～20年後には49％の職業が機械に代替され、2011年にアメリカの小学校に入学した子どもたちの65％は、今はまだ存在していない職業に就くだろうという予測があります（おそらくそのほとんどがコンピュータに深く関係するでしょう）。新指導要領でも｢主体的･対話的で深い学び｣（アクティブ･ラーニング）が求められており、今後の変化の大きい世界に対応する力を育てようとしていることがわかります。しかし、そうは言っても具体的にどのように学習を進めればよいのでしょうか。

{% floatbox {
    img: 'boards.webp',
    title: '教育用ボード各種',
    width: '400px',
    colortheme: 'silver'
} %}
画像上：Raspberry pi Zero WH。小さいけれど、れっきとした Linux コンピュータ。  
左：英国で11歳と12歳の小学生全員に配布されているmicor:bit  
右：当塾で使用予定のRaspberry Pi 3B+。いずれも小型で安価。※ 4B にアップグレードの予定  
下：フリスクブラックミント。からい。
{% endfloatbox %}

## 学習は本来楽しいもの

知らなかったことを知る、できなかったことができるようになる、それは本来とても楽しいはずのものです。しかし、親だけではなく本人でさえ、「できるようになった」よりも「できなかった」の方に目が行きがちです。そして「できた」ことは正しく評価されないまま、「勉強はイヤなもの」になっていくのです。 今後プログラミングが学校での学習に取り入れられていく中で、同じことが起こらないとは言えません。

## プログラミングを楽しもう

コンピュータプログラミングは成果が「アプリ」という形で残るため「できた」ことが本人にも分かりやすく、自分で作ったアプリで遊んだり、ＰＣ操作や生活を便利にしたりすることで大きな充実感を得ることができます。簡単に言うと「楽しい」のです。楽しければ理解も進み、創意工夫をする意欲もわいてきます。それはまさに「アクティブラーニング」そのものです。わたしたちは、プログラミングを通して「学習」の楽しさを取り戻すお手伝いができれば、と考えています。

## カリキュラム

基本的に高校の情報の要領に沿ったものを、Raspberry Pi と『オコゲ』を使って進めていきます。また、中学生以上ではプログラミングだけではなく授業形式でコンピュータの基礎からネットリテラシーまで幅広く行います。受講者の年齢や理解度に合わせた内容となりますが、「高校の要領」とは言っても、小学生にも十分理解できるものです。具体的な内容については、[『情報コース』「もっとくわしく編」](/2022-04-27_ict-motto/)をご覧ください。

{% blogcard {link:'http://ocoge.club/2022-04-27_ict-motto/'} %}

『オコゲ』に慣れたら、本格的なプログラム言語にステップアップすることもできます。『オコゲ』内部でも使用されている Javascript から始めて（以下２つはプログラミング言語ではありませんが）HTML 、CSS と進めば、立派な Web アプリ技術者の出来上がり（？）です。

## 最後に、上野学習塾

プログラミングは総合的な知的活動です。数学的・論理的な思考や国語力などを同時に要求されます。例えばゲームを作るために物体が落下するアニメーションを描画するのに、中学3年で学習する2次関数（数学）や物体の運動（理科）の知識がないと自然な動きを作ることはできません。
また、文科省が目指す「アクティブラーニング」ですが、一見「暗記中心の学習からの脱却」に見えますが、実はそうではなく「基礎はできて当たり前」という前提があってその上で創造的な学習をという内容となっています。大学入試ではその傾向がはっきりしており、「英検準2級を持っていない学生は出願すら受け付けない」という大学が学科を問わず増加しているという話を聞きます。あくまで、基礎学力が基準を満たしていることが前提なのです。
と、いう訳で、『情報コース』と共に[上野学習塾『学習コース』](https://ueno.me)をオススメしております。是非、合わせてご検討くださいませ。

<span class="text-sm">講師について…東京学芸大学特別教科教員養成課程卒業後、東電ソフトウェア炉心管理システム部に在籍、ウラン濃縮シミュレーション作成チームに所属したりした。</span>

## 『おこげ俱楽部』について

『おこげ俱楽部』は、「情報コース」ポータルサイトです。『オコゲ』や Raspberry Pi をはじめとする SBC（シングルボードコンピュータ）の情報を発信しています。

{% blogcard {link:'https://ocoge.club'} %}